<template>
    <section class="section-item bg-gray">
	<!-- Container Start -->
	<div class="container">
		<div class="row">
			<!-- Left sidebar -->
			<div class="col-md-8">
				<div class="product-details">
					<h1 class="product-title">{{ title }}</h1>

					<!-- product slider -->
                    <div class="col-md-10 offset-md-1">
                        <carousel :items="arrayImagenes" ></carousel>
                    </div>
                    <!-- product slider -->

					<div class="content mt-5 pt-5">
						<ul class="nav nav-pills  justify-content-center" id="pills-tab" role="tablist">
							<li class="nav-item">
								<a class="nav-link active" id="pills-home-tab" data-toggle="pill" href="#pills-home" role="tab" aria-controls="pills-home"
								 aria-selected="true">Product Details</a>
							</li>
						</ul>
						<div class="tab-content" id="pills-tabContent">
							<div class="tab-pane fade show active" id="pills-home" role="tabpanel" aria-labelledby="pills-home-tab">
								<h3 class="tab-title">Description</h3>
								<p>{{description}}</p>
							</div>
						</div>
					</div>
				</div>
			</div>
			<div class="col-md-4">
				<div class="sidebar">
					<!-- User Profile widget -->
					<div class="widget user">
						<h4 style="color: brown !important">Opening Price: $ {{ price }}</h4>

						<div v-if="max_bid > 0">
							<h5 style="color: red !important">Last Bid: $ {{ max_bid }}</h5>
						</div>
						<div v-else>
							<h5 style="color: red !important;">No bids yet!</h5>
						</div>

						<count-down :date="deadline"></count-down>

						<div v-if="max_bid > 0" >
							<h4 style="margin-top: 23px !important">Bids: {{ history }}</h4>
						</div>

						<div v-if="userid !== null" >
							<div v-if="last_user !== userid" class="text-center" style="margin-top: 33px !important" >

								<div class="input-group">
									<input v-model="amount" type="text" class="form-control" id="expire" placeholder="Place bid">
									<span class="input-group-addon" @click="NewBid()">Submit Bid</span>
								</div>

								<span v-if="errorShow === 1" style="color: red">Amount invalid!!</span>

								<div class="form-check checkbox" v-if="(autobid == userid  || autobid == 0)">
									<input class="form-check-input" type="checkbox"  v-model="auto" @change="onChange()">
									<label class="form-check-label" >Auto Bid</label>
								</div>

							</div>
							<div  v-else class="text-center" style="margin-top: 33px !important">
								<h5 style="color: blue !important;">Best Bidder!!</h5>
							</div>
						</div>
					    <div v-else class="text-center">
                            <h5>To bid you must login!</h5>
                            <a href="/login" class="btn btn-outline-secondary">Login</a>
					    </div>

					</div>

				</div>
			</div>

		</div>
	</div>
	<!-- Container End -->
	</section>
</template>

<script>

import CountDown from './Layouts/CountDown';
import Carousel from './Layouts/Carousel';

export default {
	props: {
	   id: {type: Number, required: true},
	   userid : {type: Number, default: null},
    },
    components: {
		'count-down': CountDown,
        Carousel
    },
    computed: {

	},
    data () {
        return {
			base_url: window.location.origin,
			image: null,
			description: 'null',
			title: 'null',
			price: 0,
			max_bid: 0,
			auto: null,
			history: 0,
			amount: 0,
			errorShow: 0,
			deadline: null,
			last_user: null	,
			autobid: 0,
			arrayImagenes: []	,
			active: 0,

        }
    },
    computed:{

    },
    methods: {
		Show(){
			let me=this;

            axios.get('/articles/show?id=' + this.id)
            .then(function (response) {
				console.log(response);
				me.title = response.data.item[0].title;
				me.description = response.data.item[0].description;
				me.price = response.data.item[0].starting_price;
				me.image = response.data.item[0].image;

				me.max_bid = response.data.item[0].max_bid;
				me.history = response.data.item[0].history;
				me.amount = response.data.item[0].history > 0 ? response.data.item[0].max_bid + 1 : response.data.item[0].starting_price + 1 ;
				me.deadline = response.data.item[0].deadline;
				me.last_user = response.data.item[0].user_id;
				me.autobid = response.data.item[0].auto;
				me.auto = response.data.item[0].auto === me.userid ? true : false;
				//me.arrayImagenes = response.data.images;
				me.arrayImagenes = JSON.parse(JSON.stringify(response.data.images));

				//setTimeout(()=>{ me.reinit() },100);

            })
            .catch(function (error) {
                console.log(error);
            });
		},
		onChange(){
				let me=this;

				var url = '/user/configure/autobid';

				if (me.auto == false){
					url = url + '/disable';
				}

				axios.post(url, {
					'id' : this.id
				})
				.then(function (response) {
					console.log(response);
					//window.location.href = '/articles/' + me.id;
				})
				.catch(function (error) {
					console.log(error);
				});
		},
		validator(){
                this.errorShow = 0;
                if (!this.amount || this.amount <= this.max_bid) {
					this.errorShow = 1;
					return 1;
				}
				else
				 return 0;
        },
		NewBid(){

			if (this.validator()){
				console.log('levantando error:');
			}
			console.log('llamando post');

			let me=this;

			var url = '/articles/bid';

			if (me.history > 0){
				url = url + '/update' ;
			}

			axios.post(url, {
				'article' : this.id ,
				'amount' : this.amount
			})
            .then(function (response) {
				console.log(response);
				window.location.href = '/articles/' + me.id;
            })
            .catch(function (error) {
                console.log(error);
            });
		},
	},
	created(){
		this.Show();
	},
	mounted() {

	},
}
</script>



